-- Atoms by Matt Arriola
-- See atoms.doc
sequence k_atom_names, k_atom_values, k_atom_IDs
k_atom_names={} k_atom_values={} k_atom_IDs={}
function remove(sequence s,integer i)
    if i=1 then
	return s[2..length(s)]
    elsif i=length(s) then
	return s[1..length(s)-1]
    end if
    return s[1..i-1]&s[i+1..length(s)]
end function
global function k_add_atom(sequence name,object x)
    integer id id=0
    k_atom_names = append(k_atom_names,name)
    k_atom_values = append(k_atom_values,x)
    for i = 1 to length(k_atom_IDs) do
	if k_atom_IDs[i] > id then
	    id=k_atom_IDs[i]
	end if
    end for
    id += 1
    k_atom_IDs &= id
    return id
end function
global function k_delete_atom(integer id)
    integer i
    i=find(id,k_atom_IDs)
    if i then
	k_atom_names=remove(k_atom_names,i)
	k_atom_values=remove(k_atom_values,i)
	k_atom_IDs=remove(k_atom_IDs,i)
	return 1
    end if
    return 0
end function
global function k_find_atom(sequence name)
    integer i
    i=find(name,k_atom_names)
    if i then
	return k_atom_IDs[i]
    end if
    return 0
end function
global function k_get_atom(integer id)
    integer i
    i=find(id,k_atom_IDs)
    if i then
	return k_atom_values[i]
    end if
    return 0
end function
