-- Standard console I/O driver for EuOS
-- creates /dev/stdin, /dev/stdout, and /dev/stderr
-- by Jeffrey Fielding (JJProg@cyberbury.net)
include graphics.e
-- stdin
integer k_stdin_fd, k_stdin_handler
k_stdin_fd = -1
global function k_stdin_open(sequence file, sequence mode)
	if compare(mode,"r") and compare(mode,"rb") then
		return -1
	end if
	if k_stdin_fd = -1 then
		k_stdin_fd = k_allocfd(k_stdin_handler)
	end if
	return k_stdin_fd
end function
global function k_stdin_close(integer fd)
	return 0
end function
global function k_stdin_read(integer fd, integer n)
	integer i, c
	sequence r
	r = {}
	for j = 1 to n do
		c = get_key()
		if c = -1 then
			exit
		else
			r &= c
		end if
	end for
	return r
end function
global function k_stdin_write(integer fd, object data)
	return -1
end function
global function k_stdin_seek(integer fd, atom where)
	return -1
end function
global function k_stdin_tell(integer fd)
	return -1
end function
global function k_stdin_ioctl(integer fd, integer op, object x)
	return -1
end function
k_stdin_handler = k_new_fd_handler({routine_id("k_stdin_close"),
				    routine_id("k_stdin_read"),
				    routine_id("k_stdin_write"),
				    routine_id("k_stdin_seek"),
				    routine_id("k_stdin_tell"),
				    routine_id("k_stdin_ioctl")})
-- stdout and stderr
integer k_stdout_fd, k_stderr_fd, k_stdout_handler
k_stdout_fd = -1
k_stderr_fd = -1
global function k_stdout_open(sequence file, sequence mode)
	if equal(mode,"r") or equal(mode,"rb") then
		return -1
	end if
	if equal(file,"stdout") then
		if k_stdout_fd = -1 then
			k_stdout_fd = k_allocfd(k_stdout_handler)
			? k_stdout_fd
		end if
		return k_stdout_fd
	else
		if k_stderr_fd = -1 then
			k_stderr_fd = k_allocfd(k_stdout_handler)
		end if
		return k_stderr_fd
	end if
end function
global function k_stdout_read(integer fd, integer n)
	return -1
end function
global function k_stdout_write(integer fd, object data)
	if fd = k_stdout_fd then
		puts(1,data)
	else
		puts(2,data)
	end if
	return 0
end function
global function k_stdout_seek(integer fd, atom where)
	return -1
end function
global function k_stdout_tell(integer fd)
	return get_position()
end function
global function k_stdout_ioctl(integer fd, integer op, object x)
	if op = 1 and fd = k_stdout_fd then
		position(x[1],x[2])
		return 0
	end if
	return -1
end function
k_stdout_handler = k_new_fd_handler({routine_id("k_stdin_close"),
				    routine_id("k_stdout_read"),
				    routine_id("k_stdout_write"),
				    routine_id("k_stdin_seek"),
				    routine_id("k_stdout_tell"),
				    routine_id("k_stdout_ioctl")})
k_registerDevice("stdin",routine_id("k_stdin_open"))
k_registerDevice("stdout",routine_id("k_stdout_open"))
k_registerDevice("stderr",routine_id("k_stdout_open"))
